#include <stdlib.h>
#include <Xm/Xm.h>
#include <Xm/MessageB.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/TextF.h>
#include <Xm/PushB.h>
#include "defines.h"
#include "helpsys.h"

/* Our shellWidgets need a parent */
extern Widget top_level;

/* current working directory defined elsewhere */
extern char current_wd[120];

/* Close one of the popup dialogs described herein (see below) */
void CancelCB(Widget w, XtPointer client_data, XtPointer call_data) 
{ XtDestroyWidget(w); }

/* For any of these functions:  Display this popup when you can't do that */
void NoCanDo(int x) {
  Widget topmsgbox;
  XmString nowayjose;
  Arg args[10];

  if (x == OPERATION_FAILED)
    nowayjose=XmStringCreate("Operation failed!", XmSTRING_DEFAULT_CHARSET);
  if (x == CANT_EXECUTE)
    nowayjose=XmStringCreate("You don't have permission to run that program.",
			       XmSTRING_DEFAULT_CHARSET);
  if (x == NOT_A_DIRECTORY)
    nowayjose=XmStringCreate("That's not a directory.",
			       XmSTRING_DEFAULT_CHARSET);
  if (x == DIR_NOT_EXIST)
    nowayjose=XmStringCreate("That file or directory doesn't exist.",
			       XmSTRING_DEFAULT_CHARSET);
  if (x == IT_ALREADY_EXISTS)
    nowayjose=XmStringCreate("A file or directory with that name already exists.",
			       XmSTRING_DEFAULT_CHARSET);
  if (x == NOT_EXECUTABLE)
    nowayjose=XmStringCreate("That is not an executable file.",
			       XmSTRING_DEFAULT_CHARSET);
  if (x == CANT_FIND)
    nowayjose=XmStringCreate("Can't find one of the specified files.",
			       XmSTRING_DEFAULT_CHARSET);
  if (x == CANT_READ)
    nowayjose=XmStringCreate("You don't have permission to read that.",
			       XmSTRING_DEFAULT_CHARSET);
  if (x == CANT_DELETE)
    nowayjose=XmStringCreate("You don't have permission to delete that.",
			     XmSTRING_DEFAULT_CHARSET);
  if (x == CANT_READ_DIR)
    nowayjose=XmStringCreate("You don't have permission to enter that directory.", XmSTRING_DEFAULT_CHARSET);
  if (x == CANT_WRITE_DIR)
    nowayjose=XmStringCreate("You don't have permission to write in this directory.", XmSTRING_DEFAULT_CHARSET);
  if (x == CANT_ACCESS_SRC)
    nowayjose=XmStringCreateLtoR("Cannot move or copy that file:\nCan't read source file.", XmSTRING_DEFAULT_CHARSET);
  if (x == CANT_ACCESS_DEST)
    nowayjose=XmStringCreateLtoR("Cannot move or copy that file:\nCan't write to destination file.", XmSTRING_DEFAULT_CHARSET);
  if (x == CANT_MOVE_SRC)
    nowayjose=XmStringCreateLtoR("Cannot move that file:\nCan't remove the source file.", XmSTRING_DEFAULT_CHARSET);
  if (x == SMB_NOT_RUNNING)
    nowayjose=XmStringCreateLtoR("SMB server is not running.\nStart SMB server before making changes.", XmSTRING_DEFAULT_CHARSET);

  XtSetArg(args[0], XmNmessageString, nowayjose);
  XtSetArg(args[1], XmNtitle, "bxfm: Can't do that");
  topmsgbox = XmCreateWarningDialog(top_level, "nocando_warning", args, 2);
  
  XtUnmanageChild(XmMessageBoxGetChild(topmsgbox, 
                                       XmDIALOG_CANCEL_BUTTON));
  /* Press the ok button when finished reading. */
  XtAddCallback(topmsgbox, XmNokCallback, CancelCB, NULL);
  XtAddCallback(topmsgbox, XmNhelpCallback, HelpTopic, (XtPointer) x);
  XtManageChild(topmsgbox);
  XmStringFree(nowayjose);
}



